Summary:	Very Secure File Transfer Protocol Daemon
Name:		vsftpd
Version:	3.0.5
Release:	%mkrel 1
License:	GPLv2+
Group:		System/Servers
URL:		http://vsftpd.beasts.org/
Source0:	https://security.appspot.com/downloads/%{name}-%{version}.tar.gz
Source10:	https://security.appspot.com/downloads/%{name}-%{version}.tar.gz.asc
Source1:	vsftpd.xinetd
Source2:	vsftpd.pam
Source3:	vsftpd.ftpusers
Source4:	vsftpd.user_list
#Source5:	vsftpd.init
Source6:	vsftpd_conf_migrate.sh
Source7:	vsftpd.service.bz2
Source8:	vsftpd.service
# Fedora patches
# Build patches
Patch1:		vsftpd-2.1.0-libs.patch
Patch2: 	vsftpd-2.1.0-build_ssl.patch
Patch3: 	vsftpd-2.1.0-tcp_wrappers.patch
# Use /etc/vsftpd/ instead of /etc/
Patch4:		vsftpd-2.2.2-configuration.patch
# These need review
Patch5: 	vsftpd-2.2.2-pam_hostname.patch
Patch6: 	vsftpd-close-std-fds.patch
Patch7: 	vsftpd-2.1.0-filter.patch
Patch8: 	vsftpd-2.0.5-greedy.patch
Patch9: 	vsftpd-2.1.0-userlist_log.patch
Patch10:	vsftpd-2.2.2-trim.patch
Patch12: 	vsftpd-2.2.2-daemonize_plus.patch
Patch13:	vsftpd-2.3.4-listen_ipv6.patch
Patch44:	vsftpd-disable-anonymous-access-by-default.patch
# Mageia patches
Patch101:	vsftpd-2.0.5-anon.patch
Patch102:	vsftpd-2.0.1-server_args.patch
Patch103:	vsftpd-2.2.2-use_localtime.patch
Patch104:	vsftpd-3.0.2-chowngroup.patch
# From arch:
Patch150:	vsftpd-fix-seccomp.patch
# OpenSuSE patches
Patch200:	vsftpd-drop-newpid-from-clone.patch
Patch201:	vsftpd-enable-gettimeofday-sec.patch
Requires(pre):		rpm-helper
Requires(post):    	rpm-helper
Requires(postun):  	rpm-helper
Requires(preun):    rpm-helper
Requires:	pam >= 0.59, libcap, openssl, logrotate
Provides:	ftpserver
Conflicts:	wu-ftpd
Conflicts:	proftpd
Conflicts:	ncftpd
Conflicts:	pure-ftpd
BuildRequires:	pkgconfig(libcap)
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pam-devel
BuildRequires:	tcp_wrappers-devel

%description
A Very Secure FTP Daemon - written from scratch - by Chris "One Man Security
Audit Team" Evans.

%prep
%setup -q
cp %{SOURCE1} .
%patch1 -p1 -b .libs
%patch2 -p1 -b .build_ssl
%patch3 -p1 -b .tcp_wrappers
%patch4 -p1 -b .configuration
%patch5 -p1 -b .pam_hostname
%patch6 -p1 -b .close_fds
%patch7 -p1 -b .filter
%patch8 -p1 -b .greedy
%patch9 -p1 -b .userlist_log
%patch10 -p1 -b .trim
%patch12 -p1 -b .daemonize_plus
%patch13 -p1 -b .ipv6
%patch44 -p1 -b .anonymous
%patch101 -p1 -b .anon
%patch102 -p1 -b .server_args
%patch103 -p1 -b .use_localtime
%patch104 -p1 -b .chowngroup
%patch150 -p1 -b .seccomp
%patch200 -p1 -b .newpid
%patch201 -p1 -b .gettimeofday

%build
%serverbuild

%make CFLAGS="%{optflags} -fPIE" LINK="%{ldflags}"
# should go to rh patch.
# Change a few defaults in the config:
perl -pi -e 's|#ls_recurse_enable|ls_recurse_enable|' vsftpd.conf
## Fix the /usr/local problem in the xinetd entry
#perl -pi -e 's|/usr/local/sbin/vsftpd|%{_sbindir}/vsftpd|' xinetd.d/vsftpd

%install
install -m755 vsftpd -D %{buildroot}%{_sbindir}/vsftpd
install -m600 vsftpd.conf -D %{buildroot}%{_sysconfdir}/vsftpd/vsftpd.conf
install -m644 vsftpd.xinetd -D %{buildroot}%{_sysconfdir}/xinetd.d/vsftpd-xinetd
install -m644 vsftpd.conf.5 -D %{buildroot}/%{_mandir}/man5/vsftpd.conf.5
install -m644 vsftpd.8 -D %{buildroot}%{_mandir}/man8/vsftpd.8
install -m644 RedHat/vsftpd.log -D %{buildroot}%{_sysconfdir}/logrotate.d/vsftpd
install -m644 %{SOURCE2}  -D %{buildroot}%{_sysconfdir}/pam.d/vsftpd
install -m600 %{SOURCE3}  -D %{buildroot}%{_sysconfdir}/vsftpd/ftpusers
install -m600 %{SOURCE4}  -D %{buildroot}%{_sysconfdir}/vsftpd/user_list
#install -m 755 %{SOURCE5} -D %{buildroot}%{_initrddir}/vsftpd
install -m 744 %{SOURCE6} -D %{buildroot}%{_sysconfdir}/vsftpd/vsftpd_conf_migrate.sh
install -m644 %{SOURCE8} -D %{buildroot}/lib/systemd/system/vsftpd.service

mkdir -p %{buildroot}/%{_sysconfdir}/avahi/services/
bzcat %{SOURCE7} > %{buildroot}/%{_sysconfdir}/avahi/services/%{name}.service

touch %{buildroot}%{_sysconfdir}/vsftpd/banned-emails
touch %{buildroot}%{_sysconfdir}/vsftpd/chroot-list
mkdir -p %{buildroot}/var/ftp/pub

%post
%_post_service vsftpd
if [ -x /usr/sbin/xinetd ];then
%_post_service xinetd
fi

%pre
%_pre_useradd ftp /var/ftp /bin/false

%postun
%_postun_userdel ftp

%preun
%_preun_service vsftpd
if [ -x /usr/sbin/xinetd ];then
%_post_service xinetd
fi

%files
%doc FAQ INSTALL BUGS AUDIT Changelog LICENSE README README.security REWARD SPEED TODO
%doc BENCHMARKS COPYING SECURITY/ EXAMPLE/ TUNING SIZE vsftpd.xinetd
%{_sbindir}/vsftpd
#%{_initrddir}/vsftpd
%attr(0555,ftp,ftp) %dir /var/ftp
%attr(2555,ftp,ftp) %dir /var/ftp/pub
%attr(700,root,root) %dir %{_sysconfdir}/vsftpd
%config(noreplace) %{_sysconfdir}/vsftpd/*
%config(noreplace) %{_sysconfdir}/pam.d/vsftpd
%config(noreplace) %{_sysconfdir}/logrotate.d/vsftpd
%config(noreplace) %{_sysconfdir}/avahi/services/%{name}.service
%config(noreplace) %{_sysconfdir}/xinetd.d/vsftpd-xinetd
/lib/systemd/system/vsftpd.service
%{_mandir}/*/*


%changelog
* Wed Dec 01 2021 neoclust <neoclust> 3.0.5-1.mga8
+ Revision: 1760206
- Ne version 3.0.5: Fixes CVE-2021-3618 (mga#29220)

* Tue Feb 18 2020 umeabot <umeabot> 3.0.3-11.mga8
+ Revision: 1541072
- Mageia 8 Mass Rebuild

* Thu Dec 19 2019 wally <wally> 3.0.3-10.mga8
+ Revision: 1468928
- add patch originally from Fedora to disable anonymous access by default

* Thu Dec 19 2019 wally <wally> 3.0.3-9.mga8
+ Revision: 1468918
- add patch via Arch to fix 'unable to list dirs w/ more than 31 items' (mga#25108)

* Thu Jul 11 2019 wally <wally> 3.0.3-8.mga8
+ Revision: 1420350
- add patch to allow getdents64 syscalls (mga#25108)

* Sun Sep 23 2018 umeabot <umeabot> 3.0.3-7.mga7
+ Revision: 1301642
- Mageia 7 Mass Rebuild

* Wed Aug 30 2017 guillomovitch <guillomovitch> 3.0.3-6.mga7
+ Revision: 1148595
- rebuild for latest openssl

* Sat Aug 26 2017 guillomovitch <guillomovitch> 3.0.3-5.mga7
+ Revision: 1147988
- rebuild for latest openssl

* Fri Oct 28 2016 bcornec <bcornec> 3.0.3-4.mga6
+ Revision: 1063816
- Remove SYSV init script for vsftpd to fix 19647

* Thu Mar 03 2016 umeabot <umeabot> 3.0.3-3.mga6
+ Revision: 984733
- Rebuild for openssl

* Fri Feb 12 2016 umeabot <umeabot> 3.0.3-2.mga6
+ Revision: 959171
- Mageia 6 Mass Rebuild

* Sat Jul 25 2015 cjw <cjw> 3.0.3-1.mga6
+ Revision: 857658
- add back -fPIE to CFLAGS to fix build
- remove whitespace at end of lines in specfile
+ luigiwalser <luigiwalser>
- 3.0.3

* Thu Mar 05 2015 luigiwalser <luigiwalser> 3.0.2-8.mga5
+ Revision: 817832
- update patch7 from opensuse to work effectively with vsftpd 3.0.2

* Mon Jan 19 2015 luigiwalser <luigiwalser> 3.0.2-7.mga5
+ Revision: 811515
- add from opensuse to fix gettimeofday usage with seccomp (bnc#870122)

* Wed Oct 15 2014 umeabot <umeabot> 3.0.2-6.mga5
+ Revision: 742596
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 3.0.2-5.mga5
+ Revision: 690244
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 3.0.2-4.mga4
+ Revision: 532542
- Mageia 4 Mass Rebuild

* Wed Aug 21 2013 luigiwalser <luigiwalser> 3.0.2-3.mga4
+ Revision: 468625
- add patch from opensuse to fix login problem (mga#10962)

* Mon Jan 14 2013 umeabot <umeabot> 3.0.2-2.mga3
+ Revision: 385572
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Dec 04 2012 pterjan <pterjan> 3.0.2-1.mga3
+ Revision: 326282
- Add systemd support (from Fedora)
- Update to 3.0.2
- Listen on IPv6 (Fedora patch)
+ boklm <boklm>
- update sources URL and add gpg signature

* Thu Apr 14 2011 tv <tv> 2.3.4-1.mga1
+ Revision: 85158
- new release

* Sat Feb 12 2011 bcornec <bcornec> 2.3.2-1.mga1
+ Revision: 50993
- Created package structure for vsftpd.

